## mingw-w64-frontistr-5.5-3.src.tar.zst

=== doc/requirements.txt ===
mkdocs
mkdocs-bootstrap
mkdocs-windmill
python-markdown-math
mkdocs-material

=== hecmw1/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2019 FrontISTR Commons
# This software is released under the MIT License, see License.txt
###############################################################################

project(hecmw C CXX Fortran)

set(hecmw_SOURCES)
set(hecmw_INCLUDE_DIRS)
set(hecmw_DEFINITIONS)
set(hecmw_LIBRARIES)

#
# Inherit definitions from fistr options
#
set(hecmw_INCLUDE_DIRS ${FrontISTR_INCLUDE_DIRS})
set(hecmw_DEFINITIONS ${FrontISTR_DEFINITIONS})
set(hecmw_LIBRARIES ${FrontISTR_LIBRARIES})

#
# Build for libhecmw.a
#
include(src/CMakeLists.txt)

add_library(hecmw STATIC ${hecmw_SOURCES})
target_link_libraries(hecmw ${hecmw_LIBRARIES})
target_include_directories(hecmw PUBLIC ${hecmw_INCLUDE_DIRS})
target_compile_definitions(hecmw PUBLIC ${hecmw_DEFINITIONS})

#
# Build tools
#
if(WITH_TOOLS)
  add_subdirectory(tools)
endif()

=== tests/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2019 FrontISTR Commons
# This software is released under the MIT License, see License.txt
###############################################################################

project(Fistr_Test)

find_program(BASH_PROGRAM bash)

function(GetProcThreads type np nt)
  if(type STREQUAL "serial")
    set(np 1 PARENT_SCOPE)
    set(nt 1 PARENT_SCOPE)
  elseif(type STREQUAL "openmp")
    set(np 1 PARENT_SCOPE)
    set(nt 2 PARENT_SCOPE)
  elseif(type STREQUAL "mpi")
    set(np 2 PARENT_SCOPE)
    set(nt 1 PARENT_SCOPE)
  elseif(type STREQUAL "hybrid")
    set(np 2 PARENT_SCOPE)
    set(nt 2 PARENT_SCOPE)
  endif()
endfunction(GetProcThreads)

# Get the list of tests in specified directory
function(AppendListTests rootdir list_in TEST_TARGETS)

  set(TMPLIST "${list_in}")
  file(GLOB_RECURSE TEST_ANALYSIS_MESH_FILES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "${rootdir}/*.msh")
  foreach(MESH_FILE ${TEST_ANALYSIS_MESH_FILES})
    get_filename_component(DIR_NAME ${MESH_FILE} DIRECTORY)
    list(APPEND TMPLIST ${DIR_NAME})
  endforeach()
  list(REMOVE_DUPLICATES TMPLIST)

  set(TEST_TARGETS "${TMPLIST}" PARENT_SCOPE)
endfunction(AppendListTests)

set(parallels serial)
IF(WITH_MPI)
  list(APPEND parallels mpi)
endif()
IF(WITH_OPENMP)
  list(APPEND parallels openmp)
endif()
IF(WITH_OPENMP AND WITH_MPI)
  list(APPEND parallels hybrid)
endif()
foreach(parallel IN LISTS parallels)
  GetProcThreads(${parallel} np nt)

  # Get the default list of tests
  set(TEST_TARGETS "")
  AppendListTests("analysis/*" "${TEST_TARGETS}" TEST_TARGETS)
  AppendListTests("lib/*" "${TEST_TARGETS}" TEST_TARGETS)
  AppendListTests("solver/*" "${TEST_TARGETS}" TEST_TARGETS)

  # Get the optional list of tests
  if(WITH_MUMPS)
    AppendListTests("with_mumps/*" "${TEST_TARGETS}" TEST_TARGETS)
  endif()
  if(WITH_MKL AND ( (parallel STREQUAL "serial") OR (parallel STREQUAL "openmp") ) )
    AppendListTests("with_mkl/*" "${TEST_TARGETS}" TEST_TARGETS)
  endif()
  if(WITH_ML)
    AppendListTests("with_ml/*" "${TEST_TARGETS}" TEST_TARGETS)
  endif()

  foreach(target ${TEST_TARGETS})
    get_filename_component(LAST_TEST_NAME ${target} NAME)
    if(NOT (${LAST_TEST_NAME} STREQUAL WITH_MPI))
      set(TEST_NAME "test_${parallel}_${target}")
      add_test(NAME ${TEST_NAME}
        COMMAND
          ./test.sh
            -f ${FrontISTR_BINARY_DIR}/fistr1/fistr1
            -e ${hecmw_BINARY_DIR}/tools/hecmw_part1
            -r ${hecmw_BINARY_DIR}/tools/rmerge
            -d ${target}
            -p ${np}
            -t ${nt}
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
      )
      set_tests_properties(
        ${TEST_NAME}
        PROPERTIES
          LABELS ${target},${parallel}
          ENVIRONMENT CTEST_TEST_NAME=${TEST_NAME}
      )
      unset(TEST_NAME)
    endif()
  endforeach()
endforeach()

=== docker/ci/Makefile ===
CI_REGISTRY_IMAGE  ?= registry.gitlab.com/frontistr-commons/frontistr
ARCH  ?= x86_64,aarch64,ppc64le,s390x
all: runtime build document

login:
ifeq ($(CI_BUILD_TOKEN),)
	docker login $(CI_REGISTRY_IMAGE)
else
	docker login -u gitlab-ci-token -p $(CI_BUILD_TOKEN) $(CI_REGISTRY_IMAGE)
endif

runtime: builder
	docker buildx build --push --builder multiarch --platform $(ARCH) -t $(CI_REGISTRY_IMAGE)/runtime -f Dockerfile . --target runtime
build: builder
	docker buildx build --push --builder multiarch --platform $(ARCH) -t $(CI_REGISTRY_IMAGE)/build -f Dockerfile . --target build
	docker buildx build --push --builder multiarch --platform $(ARCH) -t $(CI_REGISTRY_IMAGE)/build:metis4 -f Dockerfile . --target build-metis4
document: builder
	docker buildx build --push --builder multiarch --platform x86_64 -t $(CI_REGISTRY_IMAGE)/document      -f Dockerfile      . --target document
builder:
	-docker run --rm --privileged multiarch/qemu-user-static --reset -p yes
	-docker buildx create --name multiarch --driver docker-container

=== docker/container/Makefile ===
CI_REGISTRY_IMAGE  ?= registry.gitlab.com/frontistr-commons/frontistr
ARCH  ?= x86_64

ifdef CI_COMMIT_TAG
  TAG ?= $(CI_COMMIT_TAG)
else
  ifdef CI_COMMIT_REF_SLUG
    TAG ?= $(CI_COMMIT_REF_SLUG)
    TAG := $(shell echo $(TAG) | sed -e 's/\//__/')
  else
    TAG := _no_branch
  endif
endif

all: push

login:
ifeq ($(CI_BUILD_TOKEN),)
	docker login $(CI_REGISTRY_IMAGE)
else
	docker login -u gitlab-ci-token -p $(CI_BUILD_TOKEN) $(CI_REGISTRY_IMAGE)
endif

push: login
	-docker buildx create --name multiarch --driver docker-container
	docker buildx build --push --builder multiarch --platform $(ARCH) -t $(CI_REGISTRY_IMAGE)/fistr1:$(TAG) -f Dockerfile     --target fistr1 ../..
ifeq ($(TAG),master)
	docker buildx build --push --builder multiarch --platform $(ARCH) -t $(CI_REGISTRY_IMAGE)/fistr1:latest -f Dockerfile     --target fistr1 ../..
endif

=== fistr1/tools/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2019 FrontISTR Commons
# This software is released under the MIT License, see License.txt
###############################################################################

# neu2fstr
set(neu2fstr_SOURCES)
set(neu2fstr_INCLUDE_DIRS)
include(neu2fstr/CMakeLists.txt)
add_executable(neu2fstr ${neu2fstr_SOURCES})
target_link_libraries(neu2fstr hecmw fistr ${fistr_LIBRARIES})
target_include_directories(neu2fstr PUBLIC ${neu2fstr_INCLUDE_DIRS})

=== docker/binary/x86_64-w64-mingw32/Makefile ===
CI_REGISTRY_IMAGE  ?= registry.gitlab.com/frontistr-commons/frontistr
SUBDIRS := serial thread process hybrid

.PHONY: clean all build push $(SUBDIRS)

build: build_serial build_thread
	$(MAKE) subdir MAKECMDGOALS=$@
push: login push_serial push_thread
	$(MAKE) subdir MAKECMDGOALS=$@

subdir: $(SUBDIRS)

$(SUBDIRS):
	$(MAKE) -C $@ $(MAKECMDGOALS)

login:
ifeq ($(CI_BUILD_TOKEN),)
	docker login $(CI_REGISTRY_IMAGE)
else
	docker login -u gitlab-ci-token -p $(CI_BUILD_TOKEN) $(CI_REGISTRY_IMAGE)
endif

build_core:
	docker build -t $(CI_REGISTRY_IMAGE)/x86_64-w64-mingw32/env   -f Dockerfile . --target env
	docker build -t $(CI_REGISTRY_IMAGE)/x86_64-w64-mingw32/core  -f Dockerfile . --target core
build_serial: build_core
	docker build -t $(CI_REGISTRY_IMAGE)/x86_64-w64-mingw32/base:serial -f Dockerfile . --target serial
build_thread: build_core
	docker build -t $(CI_REGISTRY_IMAGE)/x86_64-w64-mingw32/base:thread -f Dockerfile . --target thread

push_core: build_core login
	docker push $(CI_REGISTRY_IMAGE)/x86_64-w64-mingw32/env
	docker push $(CI_REGISTRY_IMAGE)/x86_64-w64-mingw32/core
push_serial: build_serial
	docker push $(CI_REGISTRY_IMAGE)/x86_64-w64-mingw32/base:serial
push_thread: build_thread
	docker push $(CI_REGISTRY_IMAGE)/x86_64-w64-mingw32/base:thread

=== fistr1/src/analysis/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2019 FrontISTR Commons
# This software is released under the MIT License, see License.txt
###############################################################################

include(${CMAKE_CURRENT_LIST_DIR}/dynamic/CMakeLists.txt)
include(${CMAKE_CURRENT_LIST_DIR}/heat/CMakeLists.txt)
include(${CMAKE_CURRENT_LIST_DIR}/static/CMakeLists.txt)

=== fistr1/src/common/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2019 FrontISTR Commons
# This software is released under the MIT License, see License.txt
###############################################################################

list(APPEND fistr_SOURCES 
  ${CMAKE_CURRENT_LIST_DIR}/hecmw2fstr_connect_conv.c
  ${CMAKE_CURRENT_LIST_DIR}/fstr_ctrl_util.c
  ${CMAKE_CURRENT_LIST_DIR}/fstr_sort_index.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw2fstr_mesh_conv.f90
  ${CMAKE_CURRENT_LIST_DIR}/fstr_setup_util.f90
  ${CMAKE_CURRENT_LIST_DIR}/fstr_ctrl_modifier.f90
  ${CMAKE_CURRENT_LIST_DIR}/fstr_contact.f90
  ${CMAKE_CURRENT_LIST_DIR}/fstr_ctrl_common.f90
  ${CMAKE_CURRENT_LIST_DIR}/fstr_ctrl_material.f90
  ${CMAKE_CURRENT_LIST_DIR}/fstr_ctrl_static.f90
  ${CMAKE_CURRENT_LIST_DIR}/fstr_ctrl_heat.f90
  ${CMAKE_CURRENT_LIST_DIR}/fstr_ctrl_eigen.f90
  ${CMAKE_CURRENT_LIST_DIR}/fstr_ctrl_dynamic.f90
  ${CMAKE_CURRENT_LIST_DIR}/fstr_get_prop.f90
  ${CMAKE_CURRENT_LIST_DIR}/fstr_setup.f90
  ${CMAKE_CURRENT_LIST_DIR}/fstr_debug_dump.f90
  ${CMAKE_CURRENT_LIST_DIR}/fstr_precheck.f90
  ${CMAKE_CURRENT_LIST_DIR}/fstr_rcap_io.F90
)

list(APPEND fistr_INCLUDE_DIRS
  ${CMAKE_CURRENT_LIST_DIR}
)

=== fistr1/src/lib/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2019 FrontISTR Commons
# This software is released under the MIT License, see License.txt
###############################################################################

include(${CMAKE_CURRENT_LIST_DIR}/contact/CMakeLists.txt)
include(${CMAKE_CURRENT_LIST_DIR}/element/CMakeLists.txt)
include(${CMAKE_CURRENT_LIST_DIR}/physics/CMakeLists.txt)
include(${CMAKE_CURRENT_LIST_DIR}/user/CMakeLists.txt)
include(${CMAKE_CURRENT_LIST_DIR}/utilities/CMakeLists.txt)

list(APPEND fistr_SOURCES
  ${CMAKE_CURRENT_LIST_DIR}/GaussM.f90
  ${CMAKE_CURRENT_LIST_DIR}/dynamic_mass.f90
  ${CMAKE_CURRENT_LIST_DIR}/eigen_LIB.f90
  ${CMAKE_CURRENT_LIST_DIR}/heat_LIB.f90
  ${CMAKE_CURRENT_LIST_DIR}/heat_LIB_CAPACITY.f90
  ${CMAKE_CURRENT_LIST_DIR}/heat_LIB_CONDUCTIVITY.f90
  ${CMAKE_CURRENT_LIST_DIR}/heat_LIB_DFLUX.f90
  ${CMAKE_CURRENT_LIST_DIR}/heat_LIB_FILM.f90
  ${CMAKE_CURRENT_LIST_DIR}/heat_LIB_NEUTRAL.f90
  ${CMAKE_CURRENT_LIST_DIR}/heat_LIB_RADIATE.f90
  ${CMAKE_CURRENT_LIST_DIR}/m_common_struct.f90
  ${CMAKE_CURRENT_LIST_DIR}/m_fstr.f90
  ${CMAKE_CURRENT_LIST_DIR}/m_timepoint.f90
  ${CMAKE_CURRENT_LIST_DIR}/m_out.f90
  ${CMAKE_CURRENT_LIST_DIR}/m_step.f90
  ${CMAKE_CURRENT_LIST_DIR}/precheck_LIB_2d.f90
  ${CMAKE_CURRENT_LIST_DIR}/precheck_LIB_3d.f90
  ${CMAKE_CURRENT_LIST_DIR}/precheck_LIB_shell.f90
  ${CMAKE_CURRENT_LIST_DIR}/solve_LINEQ.f90
  ${CMAKE_CURRENT_LIST_DIR}/static_LIB.f90
  ${CMAKE_CURRENT_LIST_DIR}/static_LIB_1d.f90
  ${CMAKE_CURRENT_LIST_DIR}/static_LIB_2d.f90
  ${CMAKE_CURRENT_LIST_DIR}/static_LIB_3d.f90
  ${CMAKE_CURRENT_LIST_DIR}/static_LIB_3dIC.f90
  ${CMAKE_CURRENT_LIST_DIR}/static_LIB_3d_vp.f90
  ${CMAKE_CURRENT_LIST_DIR}/static_LIB_C3D4_selectiveESNS.f90
  ${CMAKE_CURRENT_LIST_DIR}/static_LIB_C3D8.f90
  ${CMAKE_CURRENT_LIST_DIR}/static_LIB_Fbar.f90
  ${CMAKE_CURRENT_LIST_DIR}/static_LIB_beam.f90
  ${CMAKE_CURRENT_LIST_DIR}/static_LIB_shell.f90
)

=== hecmw1/src/common/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2019 FrontISTR Commons
# This software is released under the MIT License, see License.txt
###############################################################################

list(APPEND hecmw_SOURCES
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_hash.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_init.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_finalize.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_comm.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_conn_conv.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_error.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_util.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_malloc.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_log.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_msg.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_msg_table.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_lib_fc.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_control.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_ctrllex.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_bit_array.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_map_int.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_set_int.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_varray_int.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_etype.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_debug_write_dist.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_reorder.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_gflex.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_heclex.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_ablex.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_io_hec.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_io_abaqus.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_io_nastran_dummy.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_io_geofem.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_io_dist.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_io_mesh.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_io_get_mesh.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_io_get_mesh_if.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_io_put_mesh.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_dist.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_dist_alloc.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_dist_print.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_dist_free.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_dist_copy_f2c.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_dist_copy_c2f.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_dist_refine.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_ucd_print.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_geometric.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_path.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_put_mesh_if.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_restart.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_bin_io.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_result.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_result_copy_c2f.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_result_copy_f2c.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_result_io.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_result_bin_io.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_result_txt_io.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_visual_if.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_system.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_time.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_util_f.F90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_logging.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_msgno_f.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_msg_f.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_control_f.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_result_f.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_restart_f.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_dist_copy_f2c_f.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_dist_copy_c2f_f.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_dist_free_f.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_dist_print_f.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_visualizer_f.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_etype_f.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_varray_int_f.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_io.f90
)

list(APPEND hecmw_INCLUDE_DIRS
  ${CMAKE_CURRENT_LIST_DIR}
)

=== hecmw1/src/etc/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2019 FrontISTR Commons
# This software is released under the MIT License, see License.txt
###############################################################################

list(APPEND hecmw_SOURCES
  ${CMAKE_CURRENT_LIST_DIR}/mpi_wrapper.c
)

=== PKGBUILD ===
# Maintainer: Rafał Brzegowy <rafal.brzegowy@yahoo.com>

_realname=frontistr
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=5.5
pkgrel=3
pkgdesc='Open-Source Large-Scale Parallel FEM Program for Nonlinear Structural Analysis (mingw-w64)'
arch=('any')
mingw_arch=('mingw64' 'ucrt64')
url="https://www.frontistr.com"
msys2_repository_url="https://github.com/frontistr/frontistr"
license=('spdx:MIT')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-omp"
         "${MINGW_PACKAGE_PREFIX}-openblas"
         "${MINGW_PACKAGE_PREFIX}-parmetis"
         "${MINGW_PACKAGE_PREFIX}-metis"
         # "${MINGW_PACKAGE_PREFIX}-mumps" Couldn't be found by cmake!
         "${MINGW_PACKAGE_PREFIX}-netcdf"
         "${MINGW_PACKAGE_PREFIX}-seacas"
         "${MINGW_PACKAGE_PREFIX}-trilinos"
         "${MINGW_PACKAGE_PREFIX}-doxygen"
         "${MINGW_PACKAGE_PREFIX}-scalapack"
         $([[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]] || echo "${MINGW_PACKAGE_PREFIX}-gcc-libgfortran"))
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-fc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-msmpi")
source=("https://github.com/${_realname}/${_realname}/archive/v${pkgver}.tar.gz")
sha256sums=('d4fb213d7b57ad84dca96949c6ece0d8a4499e4a2dd2deb2d038a2e605bf6005')

build() {
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ ${MINGW_PACKAGE_PREFIX} != *-clang-* ]]; then
    export FFLAGS="-fallow-invalid-boz"
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    ${MINGW_PREFIX}/bin/cmake -Wno-dev \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      "${_extra_config[@]}" \
      -DWITH_MPI=ON \
      -DWITH_ML=ON \
      ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
  
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"
  DESTDIR=${pkgdir} cmake --install .
  install -Dm644 ${srcdir}/${_realname}-${pkgver}/License.txt ${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE 

  local PREFIX_WIN=$(cygpath -wm ${MINGW_PREFIX})
  for _f in $(find "${pkgdir}${MINGW_PREFIX}"/lib/cmake -type f); do
    sed -e "s|${PREFIX_WIN}|\$\{_IMPORT_PREFIX\}|g" -i ${_f}
    sed -e "s|${MINGW_PREFIX}|\$\{_IMPORT_PREFIX\}|g" -i ${_f}
  done
  
}
